package io.xjar;

import java.io.OutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.util.jar.Attributes;
import java.util.jar.Manifest;
import io.xjar.jar.XJarEncryptor;
import io.xjar.boot.XBootEncryptor;
import java.util.jar.JarFile;
import java.io.File;
import io.xjar.key.XKey;
import org.apache.commons.compress.archivers.jar.JarArchiveEntry;

public class XSmartEncryptor extends XEntryEncryptor<JarArchiveEntry> implements XEncryptor, XConstants
{
    public XSmartEncryptor(final XEncryptor xEncryptor) {
        super(xEncryptor);
    }
    
    public XSmartEncryptor(final XEncryptor xEncryptor, final XEntryFilter<JarArchiveEntry> filter) {
        super(xEncryptor, filter);
    }
    
    @Override
    public void encrypt(final XKey key, final File src, final File dest) throws IOException {
        try (JarFile jar = new JarFile(src, false)) {
            final Manifest manifest = jar.getManifest();
            final Attributes attributes = manifest.getMainAttributes();
            final String version = attributes.getValue("Spring-Boot-Version");
            final XEncryptor encryptor = (XEncryptor)((version != null) ? new XBootEncryptor(this.xEncryptor, (XEntryFilter)this.filter) : new XJarEncryptor(this.xEncryptor, (XEntryFilter)this.filter));
            encryptor.encrypt(key, src, dest);
        }
    }
    
    @Override
    public void encrypt(final XKey key, final InputStream in, final OutputStream out) throws IOException {
        throw new UnsupportedOperationException();
    }
}
